MediaWiki搭建以及pivot皮肤配置
==============================

### 一、所需环境以及软件

#### 1、nginx v1.57+

#### 2、PHP v7.3.19 or v7.4.9+

#### 3、mysql v5.5.8+

#### 4、MediaWiki v1.36.1

#### 5、pivot v2.3.0

#### 6、php扩展

* ##### php-fpm
* ##### mbstring
* ##### xml
* ##### intl
* ##### mysql

### 二、安装nginx

```bash
sudo apt-get install nginx
```

### 三、安装PHP

#### 1、安装新版本PHP需要使用其他软件源

```bash
sudo apt install software-properties-common
sudo add-apt-repository ppa:ondrej/php
```

#### 2、进行安装

```bash
sudo apt install php7.4
php -v #查看版本
```

> 默认安装7.4版本中最新的版本 目前是7.4.21

#### 3、安装PHP扩展

```bash
sudo agt install php-fpm
sudo apt install php7.4-mbstring php7.4-xml php7.4-intl php7.4-mysql
```

### 四、配置MediaWiki

#### 1、下载压缩包上传至服务器（[下载地址](https://www.mediawiki.org/wiki/Download)）

#### 2、解压至任意路径

```bash
tar zxvf <压缩包>
```

#### 3、配置nginx进行代理

```bash
#进入nginx目录下
cd /etc/nginx
#打开配置文件
sudo vim nginx.conf
#更改第一行 user root; 后保存退出
user root;
#进入该文件夹
cd sites-available
#复制一份文件名称为wiki
sudo cp default wiki
#打开wiki
sudo vim wiki
#打开后删除里面所有内容后将一下内容添加进去
server {
	listen <端口号>  default_server;
	listen [::]:<端口号> default_server;

	root <wiki解压后的路径例：/home/dev/software/MediaWiki/mediawiki-1.36.1;>

	index index.html index.htm index.nginx-debian.html index.php;

	server_name _;

	location ~ \.php$ {
		include snippets/fastcgi-php.conf;
		fastcgi_pass unix:/var/run/php/php7.4-fpm.sock;
	}
}
#注意修改端口号以及路径 修改完成后保存退出，跳转到以下路径
cd ../sites-enabled
#创建软连接
sudo ln -s /etc/nginx/sites-available/wiki wiki
#重启nginx 以及php7.4-fpm
sudo service nginx restart
sudo systemctl restart php7.4-fpm.service
```

#### 4、配置MediaWiki

* ##### 打开浏览器输入http://<安装wiki的服务器ip地址>:<在nginx配置的端口号>
* ##### 根据引导依次进行配置
* ##### 数据库选择mysql 填写数据库的地址，用户名，密码会自动初始化数据库
* ##### 设置wiki的名称，以及管理员账号
* ##### 设置wiki用户权限皮肤编辑器等后
* ##### 点击继续进行安装，安装时间较长有可能会出现504网关超时，点击刷新继续提交
* ##### 完成后下载生成的LocalSettings.php文件 将其上传至服务器wiki的根目录（index.php的同级目录）中。
* ##### 进入MediaWiki http://<服务器ip>:<端口号>/index.php

### 五、配置pivot皮肤 [git地址](https://github.com/Hutchy68/pivot)

#### 1、下载皮肤包后进行解压，修改名称为pivot [下载地址](https://github.com/hutchy68/pivot/archive/master.zip)。

#### 2、上传皮肤包到服务器wiki根目录下的skins目录中

#### 3、打开wiki根目录下的LocalSettings.php文件夹进行修改

```bash
$wgDefaultSkin = "pivot"; #指定为默认皮肤
wfLoadSkin( 'pivot' );
$wgPivotFeatures = array(
	'showActionsForAnon' => true,
	'fixedNavBar' => false,
	'usePivotTabs' => false,
	'showHelpUnderTools' => true,
	'showRecentChangesUnderTools' => true,
	'wikiName' => &$GLOBALS['wgSitename'],
	'wikiNameDesktop' => &$GLOBALS['wgSitename'],
	'navbarIcon' => false,
	'preloadFontAwesome' => false,
	'showFooterIcons' => true,
	'addThisPUBID' => '',
	'useAddThisShare' => '',
	'useAddThisFollow' => ''
);
```

> ```
> 使用以下功能
> ```
>
> `LocalSettings.php`来更改行为。
>
> * `'showActionsForAnon' => true` 显示未登录访问者的页面操作。
> * `'fixedNavBar' => false`将允许导航栏随内容滚动，`true`将锁定导航栏。
> * `'usePivotTabs' => false` 设置为 true 以在 wiki 页面中启用 Foundation 选项卡标记。
> * `'showHelpUnderTools' => true` 将在“工具”下创建指向“帮助”的链接。
> * `'showRecentChangesUnderTool's => true` 将在“工具”下创建指向“最近更改”的链接。
> * `'wikiName' => &$GLOBALS['wgSitename']`默认是站点名称。设置为在不更改系统 wikiname 的情况下显示简短版本。
> * `'wikiNameDesktop' => &$GLOBALS['wgSitename']`默认站点名称。设置为在桌面视图中显示更长的名称。
> * `'navbarIcon' => false`移动视图中没有图标，`true`以使用 wiki 的全局设置徽标路径图像。
> * `'preloadFontAwesome' => false`设置为 true 以将 Font Awesome 预加载为 `<head>`元素。有助于克服未正确设置的 MIME 类型服务器配置。
> * `'showFooterIcons' => false`将显示文本代替页脚图标，`true`将输出全局设置的图标。
> * `'addThisPUBID' => ''`空字符串不会触发 AddThis 脚本，`'ra-##-#######'`发布者 ID 将仅允许在内容页面上异步运行 AddThis 脚本。
> * `'useAddThisShare' => ''`默认空字符串，不使用 AddThis 共享，`your_addthis_specific_div_class_string`将直接在页面标题下插入共享工具箱 div，但在带有自定义 div 类的标语之前。
> * `'useAddThisFollow' => ''`默认为空字符串，不使用 AddThis follow，`your_addthis_specific_div_class_string`将使用 `right-footer`自定义 div 类在图标或文本输出之前的区域中插入关注工具箱 div 。

#### 4、皮肤配置完成，用户登录后可以在个人中心来选择要使用的皮肤